diff --git a/Makefile b/Makefile
index 6bb9cf55f2..e9264ca1e5 100644
--- a/Makefile
+++ b/Makefile
@@ -933,7 +933,7 @@ ALL-y += u-boot-sunxi-with-spl.bin
 endif
 
 # enable combined SPL/u-boot/dtb rules for tegra
-ifeq ($(CONFIG_TEGRA)$(CONFIG_SPL),yy)
+ifeq ($(CONFIG_ARCH_TEGRA)$(CONFIG_SPL),yy)
 ALL-y += u-boot-tegra.bin u-boot-nodtb-tegra.bin
 ALL-$(CONFIG_OF_SEPARATE) += u-boot-dtb-tegra.bin
 endif
@@ -1626,7 +1626,7 @@ u-boot-sunxi-with-spl.bin: spl/sunxi-spl.bin u-boot.itb FORCE
 endif
 endif
 
-ifneq ($(CONFIG_TEGRA),)
+ifneq ($(CONFIG_ARCH_TEGRA),)
 ifneq ($(CONFIG_BINMAN),)
 # Makes u-boot-dtb-tegra.bin u-boot-tegra.bin u-boot-nodtb-tegra.bin
 %-dtb-tegra.bin %-tegra.bin %-nodtb-tegra.bin: \
diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index 91185b9299..574d1e246f 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -1142,7 +1142,7 @@ config ARCH_ZYNQMP
 	imply MP
 	imply DM_USB_GADGET
 
-config TEGRA
+config ARCH_TEGRA
 	bool "NVIDIA Tegra"
 	imply DISTRO_DEFAULTS
 	imply FAT_WRITE
diff --git a/arch/arm/Makefile b/arch/arm/Makefile
index 9b3ca9772c..e91b37fb34 100644
--- a/arch/arm/Makefile
+++ b/arch/arm/Makefile
@@ -1,6 +1,6 @@
 # SPDX-License-Identifier: GPL-2.0+
 
-ifeq ($(CONFIG_SPL_BUILD)$(CONFIG_TEGRA),yy)
+ifeq ($(CONFIG_SPL_BUILD)$(CONFIG_ARCH_TEGRA),yy)
 CONFIG_CPU_V7A=
 CONFIG_CPU_ARM720T=y
 endif
@@ -22,7 +22,7 @@ arch-$(CONFIG_ARM64)		=-march=armv8-a
 
 # On Tegra systems we must build SPL for the armv4 core on the device
 # but otherwise we can use the value in CONFIG_SYS_ARM_ARCH
-ifeq ($(CONFIG_SPL_BUILD)$(CONFIG_TEGRA),yy)
+ifeq ($(CONFIG_SPL_BUILD)$(CONFIG_ARCH_TEGRA),yy)
 arch-y += -D__LINUX_ARM_ARCH__=4
 else
 arch-y += -D__LINUX_ARM_ARCH__=$(CONFIG_SYS_ARM_ARCH)
@@ -76,8 +76,7 @@ machine-$(CONFIG_ARCH_SOCFPGA)		+= socfpga
 machine-$(CONFIG_STM32)			+= stm32
 machine-$(CONFIG_ARCH_STM32MP)		+= stm32mp
 machine-$(CONFIG_ARCH_SUNXI)		+= sunxi
-# TODO: rename CONFIG_TEGRA -> CONFIG_ARCH_TEGRA
-machine-$(CONFIG_TEGRA)			+= tegra
+machine-$(CONFIG_ARCH_TEGRA)		+= tegra
 machine-$(CONFIG_ARCH_U8500)		+= u8500
 machine-$(CONFIG_ARCH_UNIPHIER)		+= uniphier
 machine-$(CONFIG_ARCH_VERSAL)		+= versal
diff --git a/arch/arm/cpu/arm720t/interrupts.c b/arch/arm/cpu/arm720t/interrupts.c
index 8437717a7b..f0fc58dead 100644
--- a/arch/arm/cpu/arm720t/interrupts.c
+++ b/arch/arm/cpu/arm720t/interrupts.c
@@ -11,7 +11,7 @@
 
 #include <common.h>
 
-#if defined(CONFIG_TEGRA)
+#if defined(CONFIG_ARCH_TEGRA)
 static ulong timestamp;
 static ulong lastdec;
 
diff --git a/arch/arm/cpu/armv7/Kconfig b/arch/arm/cpu/armv7/Kconfig
index 73d57a2aae..14569e560b 100644
--- a/arch/arm/cpu/armv7/Kconfig
+++ b/arch/arm/cpu/armv7/Kconfig
@@ -19,7 +19,7 @@ config ARMV7_NONSEC
 config ARMV7_BOOT_SEC_DEFAULT
 	bool "Boot in secure mode by default" if EXPERT
 	depends on ARMV7_NONSEC
-	default y if TEGRA
+	default y if ARCH_TEGRA
 	---help---
 	Say Y here to boot in secure mode by default even if non-secure mode
 	is supported. This option is useful to boot kernels which do not
diff --git a/arch/arm/dts/Makefile b/arch/arm/dts/Makefile
index 49f79f6eb0..e410eac5c8 100644
--- a/arch/arm/dts/Makefile
+++ b/arch/arm/dts/Makefile
@@ -159,7 +159,7 @@ dtb-$(CONFIG_ARCH_MESON) += \
 	meson-g12b-a311d-khadas-vim3.dtb \
 	meson-sm1-khadas-vim3l.dtb \
 	meson-sm1-sei610.dtb
-dtb-$(CONFIG_TEGRA) += tegra20-harmony.dtb \
+dtb-$(CONFIG_ARCH_TEGRA) += tegra20-harmony.dtb \
 	tegra20-medcom-wide.dtb \
 	tegra20-paz00.dtb \
 	tegra20-plutux.dtb \
diff --git a/arch/arm/mach-tegra/Kconfig b/arch/arm/mach-tegra/Kconfig
index ff9f29f2d5..00facf492e 100644
--- a/arch/arm/mach-tegra/Kconfig
+++ b/arch/arm/mach-tegra/Kconfig
@@ -1,4 +1,4 @@
-if TEGRA
+if ARCH_TEGRA
 
 config SPL_GPIO_SUPPORT
 	default y
diff --git a/common/spl/Kconfig b/common/spl/Kconfig
index ef5bf66696..8c4de8e506 100644
--- a/common/spl/Kconfig
+++ b/common/spl/Kconfig
@@ -979,7 +979,7 @@ config SPL_POWER_DOMAIN
 
 config SPL_RAM_SUPPORT
 	bool "Support booting from RAM"
-	default y if MICROBLAZE || ARCH_SOCFPGA || TEGRA || ARCH_ZYNQ
+	default y if MICROBLAZE || ARCH_SOCFPGA || ARCH_TEGRA || ARCH_ZYNQ
 	help
 	  Enable booting of an image in RAM. The image can be preloaded or
 	  it can be loaded by SPL directly into RAM (e.g. using USB).
@@ -987,7 +987,7 @@ config SPL_RAM_SUPPORT
 config SPL_RAM_DEVICE
 	bool "Support booting from preloaded image in RAM"
 	depends on SPL_RAM_SUPPORT
-	default y if MICROBLAZE || ARCH_SOCFPGA || TEGRA || ARCH_ZYNQ
+	default y if MICROBLAZE || ARCH_SOCFPGA || ARCH_TEGRA || ARCH_ZYNQ
 	help
 	  Enable booting of an image already loaded in RAM. The image has to
 	  be already in memory when SPL takes over, e.g. loaded by the boot
diff --git a/config.mk b/config.mk
index 097d1f67d2..7bb1fd4ed1 100644
--- a/config.mk
+++ b/config.mk
@@ -23,7 +23,7 @@ VENDOR :=
 ARCH := $(CONFIG_SYS_ARCH:"%"=%)
 CPU := $(CONFIG_SYS_CPU:"%"=%)
 ifdef CONFIG_SPL_BUILD
-ifdef CONFIG_TEGRA
+ifdef CONFIG_ARCH_TEGRA
 CPU := arm720t
 endif
 endif
diff --git a/configs/apalis-tk1_defconfig b/configs/apalis-tk1_defconfig
index 150941fd1a..604a473fa9 100644
--- a/configs/apalis-tk1_defconfig
+++ b/configs/apalis-tk1_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_SYS_MALLOC_F_LEN=0x2000
 CONFIG_ENV_SIZE=0x2000
diff --git a/configs/apalis_t30_defconfig b/configs/apalis_t30_defconfig
index b2e3ff6614..a5db39129e 100644
--- a/configs/apalis_t30_defconfig
+++ b/configs/apalis_t30_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_SYS_MALLOC_F_LEN=0x2000
 CONFIG_ENV_SIZE=0x2000
diff --git a/configs/beaver_defconfig b/configs/beaver_defconfig
index d70467012c..89f4dc1144 100644
--- a/configs/beaver_defconfig
+++ b/configs/beaver_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/cardhu_defconfig b/configs/cardhu_defconfig
index 6145861060..bf2f5f5208 100644
--- a/configs/cardhu_defconfig
+++ b/configs/cardhu_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/cei-tk1-som_defconfig b/configs/cei-tk1-som_defconfig
index c30b37e8c7..366a90dd42 100644
--- a/configs/cei-tk1-som_defconfig
+++ b/configs/cei-tk1-som_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/colibri_t20_defconfig b/configs/colibri_t20_defconfig
index cf3e4e0beb..a1d6ab206a 100644
--- a/configs/colibri_t20_defconfig
+++ b/configs/colibri_t20_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_SYS_MALLOC_F_LEN=0x2000
 CONFIG_ENV_SIZE=0x10000
diff --git a/configs/colibri_t30_defconfig b/configs/colibri_t30_defconfig
index 4937433af0..d44ed05784 100644
--- a/configs/colibri_t30_defconfig
+++ b/configs/colibri_t30_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_SYS_MALLOC_F_LEN=0x2000
 CONFIG_ENV_SIZE=0x2000
diff --git a/configs/dalmore_defconfig b/configs/dalmore_defconfig
index cad56f131b..483a7cfeb5 100644
--- a/configs/dalmore_defconfig
+++ b/configs/dalmore_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/e2220-1170_defconfig b/configs/e2220-1170_defconfig
index d9f110ce1e..da418de4cd 100644
--- a/configs/e2220-1170_defconfig
+++ b/configs/e2220-1170_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80080000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/harmony_defconfig b/configs/harmony_defconfig
index 197add3945..ec8f4dad22 100644
--- a/configs/harmony_defconfig
+++ b/configs/harmony_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0x1FFE0000
diff --git a/configs/jetson-tk1_defconfig b/configs/jetson-tk1_defconfig
index 116950ea7b..74f4456d89 100644
--- a/configs/jetson-tk1_defconfig
+++ b/configs/jetson-tk1_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/medcom-wide_defconfig b/configs/medcom-wide_defconfig
index bfca54d857..95c9dfa807 100644
--- a/configs/medcom-wide_defconfig
+++ b/configs/medcom-wide_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0x1FFE0000
diff --git a/configs/nyan-big_defconfig b/configs/nyan-big_defconfig
index 2b1bcb8695..8abb1a432a 100644
--- a/configs/nyan-big_defconfig
+++ b/configs/nyan-big_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x81000100
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/p2371-0000_defconfig b/configs/p2371-0000_defconfig
index 3c183df470..d8d28ed6ea 100644
--- a/configs/p2371-0000_defconfig
+++ b/configs/p2371-0000_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80080000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/p2371-2180_defconfig b/configs/p2371-2180_defconfig
index 3aa6f578d7..ec4c5909ac 100644
--- a/configs/p2371-2180_defconfig
+++ b/configs/p2371-2180_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80080000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/p2571_defconfig b/configs/p2571_defconfig
index 37685eaebc..95188a142a 100644
--- a/configs/p2571_defconfig
+++ b/configs/p2571_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80080000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/p2771-0000-000_defconfig b/configs/p2771-0000-000_defconfig
index e3d42a20e7..befa46a4cd 100644
--- a/configs/p2771-0000-000_defconfig
+++ b/configs/p2771-0000-000_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80080000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/p2771-0000-500_defconfig b/configs/p2771-0000-500_defconfig
index 51715d0b23..71cde4e41d 100644
--- a/configs/p2771-0000-500_defconfig
+++ b/configs/p2771-0000-500_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80080000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/p3450-0000_defconfig b/configs/p3450-0000_defconfig
index c12d58a44d..2bf8f97ca2 100644
--- a/configs/p3450-0000_defconfig
+++ b/configs/p3450-0000_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80080000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/paz00_defconfig b/configs/paz00_defconfig
index 8536c64fc0..4330d141a3 100644
--- a/configs/paz00_defconfig
+++ b/configs/paz00_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/plutux_defconfig b/configs/plutux_defconfig
index 3c716d6e27..6b70a240f5 100644
--- a/configs/plutux_defconfig
+++ b/configs/plutux_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0x1FFE0000
diff --git a/configs/seaboard_defconfig b/configs/seaboard_defconfig
index 9c285b96aa..ba19ceb5ac 100644
--- a/configs/seaboard_defconfig
+++ b/configs/seaboard_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/tec-ng_defconfig b/configs/tec-ng_defconfig
index 2fc0470b34..d31db78818 100644
--- a/configs/tec-ng_defconfig
+++ b/configs/tec-ng_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/tec_defconfig b/configs/tec_defconfig
index fd7b1b6267..34df740bc5 100644
--- a/configs/tec_defconfig
+++ b/configs/tec_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0x1FFE0000
diff --git a/configs/trimslice_defconfig b/configs/trimslice_defconfig
index fb9be305b6..230a3b836d 100644
--- a/configs/trimslice_defconfig
+++ b/configs/trimslice_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFE000
diff --git a/configs/venice2_defconfig b/configs/venice2_defconfig
index 94211e5091..58fb867e9e 100644
--- a/configs/venice2_defconfig
+++ b/configs/venice2_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x80110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/configs/ventana_defconfig b/configs/ventana_defconfig
index bb94e23ad5..9ff4f1c8ac 100644
--- a/configs/ventana_defconfig
+++ b/configs/ventana_defconfig
@@ -1,5 +1,5 @@
 CONFIG_ARM=y
-CONFIG_TEGRA=y
+CONFIG_ARCH_TEGRA=y
 CONFIG_SYS_TEXT_BASE=0x00110000
 CONFIG_ENV_SIZE=0x2000
 CONFIG_ENV_OFFSET=0xFFFFE000
diff --git a/disk/Kconfig b/disk/Kconfig
index 747275c2ba..cee16a80bc 100644
--- a/disk/Kconfig
+++ b/disk/Kconfig
@@ -53,7 +53,7 @@ config ISO_PARTITION
 	bool "Enable ISO partition table"
 	depends on PARTITIONS
 	default y if DISTRO_DEFAULTS
-	default y if MIPS || TEGRA
+	default y if MIPS || ARCH_TEGRA
 
 config SPL_ISO_PARTITION
 	bool "Enable ISO partition table for SPL"
@@ -75,7 +75,7 @@ config EFI_PARTITION
 	bool "Enable EFI GPT partition table"
 	depends on PARTITIONS
 	default y if DISTRO_DEFAULTS
-	default y if TEGRA
+	default y if ARCH_TEGRA
 	select LIB_UUID
 	help
 	  Say Y here if you would like to use device under U-Boot which
diff --git a/drivers/i2c/Kconfig b/drivers/i2c/Kconfig
index e42b6516bf..f8b18de8f3 100644
--- a/drivers/i2c/Kconfig
+++ b/drivers/i2c/Kconfig
@@ -402,7 +402,7 @@ config SYS_I2C_STM32F7
 
 config SYS_I2C_TEGRA
 	bool "NVIDIA Tegra internal I2C controller"
-	depends on TEGRA
+	depends on ARCH_TEGRA
 	help
 	  Support for NVIDIA I2C controller available in Tegra SoCs.
 
diff --git a/drivers/mailbox/Kconfig b/drivers/mailbox/Kconfig
index 85c2a829ae..dd4b0ac0c3 100644
--- a/drivers/mailbox/Kconfig
+++ b/drivers/mailbox/Kconfig
@@ -19,7 +19,7 @@ config SANDBOX_MBOX
 
 config TEGRA_HSP
 	bool "Enable Tegra HSP controller support"
-	depends on DM_MAILBOX && TEGRA
+	depends on DM_MAILBOX && ARCH_TEGRA
 	help
 	  This enables support for the NVIDIA Tegra HSP Hw module, which
 	  implements doorbells, mailboxes, semaphores, and shared interrupts.
diff --git a/drivers/mmc/Kconfig b/drivers/mmc/Kconfig
index 8f0df568b9..3c4f057373 100644
--- a/drivers/mmc/Kconfig
+++ b/drivers/mmc/Kconfig
@@ -616,7 +616,7 @@ config MMC_SDHCI_TANGIER
 
 config MMC_SDHCI_TEGRA
 	bool "SDHCI platform support for the Tegra SD/MMC Controller"
-	depends on TEGRA
+	depends on ARCH_TEGRA
 	select BOUNCE_BUFFER
 	default y
 	help
diff --git a/drivers/pci/Kconfig b/drivers/pci/Kconfig
index 437cd9a055..6fc26884e2 100644
--- a/drivers/pci/Kconfig
+++ b/drivers/pci/Kconfig
@@ -111,7 +111,7 @@ config PCI_SANDBOX
 
 config PCI_TEGRA
 	bool "Tegra PCI support"
-	depends on TEGRA
+	depends on ARCH_TEGRA
 	depends on (TEGRA186 && POWER_DOMAIN) || (!TEGRA186)
 	help
 	  Enable support for the PCIe controller found on some generations of
diff --git a/drivers/usb/host/Kconfig b/drivers/usb/host/Kconfig
index 0d54fdad8a..0ba010b034 100644
--- a/drivers/usb/host/Kconfig
+++ b/drivers/usb/host/Kconfig
@@ -197,7 +197,7 @@ config USB_EHCI_PCI
 
 config USB_EHCI_TEGRA
 	bool "Support for NVIDIA Tegra on-chip EHCI USB controller"
-	depends on TEGRA
+	depends on ARCH_TEGRA
 	---help---
 	  Enable support for Tegra on-chip EHCI USB controller
 
diff --git a/drivers/video/Kconfig b/drivers/video/Kconfig
index 7c5012a67f..38123543a5 100644
--- a/drivers/video/Kconfig
+++ b/drivers/video/Kconfig
@@ -128,7 +128,7 @@ config CONSOLE_TRUETYPE_SIZE
 
 config SYS_WHITE_ON_BLACK
 	bool "Display console as white on a black background"
-	default y if ARCH_AT91 || ARCH_EXYNOS || ARCH_ROCKCHIP || TEGRA || X86 || ARCH_SUNXI
+	default y if ARCH_AT91 || ARCH_EXYNOS || ARCH_ROCKCHIP || ARCH_TEGRA || X86 || ARCH_SUNXI
 	help
 	 Normally the display is black on a white background, Enable this
 	 option to invert this, i.e. white on a black background. This can be
diff --git a/include/serial.h b/include/serial.h
index 54b21a0470..c590637b1f 100644
--- a/include/serial.h
+++ b/include/serial.h
@@ -28,7 +28,7 @@ extern struct serial_device *default_serial_console(void);
 
 #if	defined(CONFIG_MPC83xx) || defined(CONFIG_MPC85xx) || \
 	defined(CONFIG_MPC86xx) || \
-	defined(CONFIG_TEGRA) || defined(CONFIG_SYS_COREBOOT) || \
+	defined(CONFIG_ARCH_TEGRA) || defined(CONFIG_SYS_COREBOOT) || \
 	defined(CONFIG_MICROBLAZE)
 extern struct serial_device serial0_device;
 extern struct serial_device serial1_device;